"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = convertComponentsDefining;

var _utils = require("./utils");

/**
 * When defining a component with PascalCase like MyComponentName,
 * you can use either case when referencing its custom element.
 * That means both <my-component-name> and <MyComponentName> are acceptable.
 */
function convertComponentsDefining(definedComponents) {
  var names = Object.keys(definedComponents);

  for (var i = 0, l = names.length; i < l; i++) {
    if (/[A-Z]/.test(names[i][0])) {
      var camelCase = names[i][0].toLowerCase() + names[i].slice(1);
      definedComponents[camelCase] = definedComponents[names[i]];
    }

    var kebabName = (0, _utils.kebabCase)(names[i]);
    definedComponents[kebabName] = definedComponents[names[i]];
  }
}