"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mixin = require("./mixin");

var _initWatch = _interopRequireDefault(require("./initWatch"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var installedPlugins = new Set();

var SFC =
/*#__PURE__*/
function () {
  function SFC(config) {
    var _this = this;

    _classCallCheck(this, SFC);

    if (_typeof(config) !== 'object') {
      throw new TypeError('SFC Config must be an object.');
    }

    if (typeof config.beforeCreate === 'function') {
      config.beforeCreate.call(null);
    }

    Object.defineProperty(this, '_watchers', {
      enumerable: false,
      value: []
    });

    if (config._global) {
      Object.defineProperty(this, '_global', {
        enumerable: false,
        value: config._global
      });
    }
    /**
     * Mixins order:
     *  1. _watchers
     *  2. props
     *  3. methods
     *  4. data & observe
     *  5. computed
     *  6. watch
     */


    (0, _mixin.mixinProps)(this, config.propsData, config.props);

    if (config.methods) {
      Object.keys(config.methods).forEach(function (methodName) {
        _this[methodName] = config.methods[methodName].bind(_this);
      });
    }

    (0, _mixin.mixinData)(this, config);
    (0, _mixin.mixinSlots)(this, config.children);
    Object.defineProperty(this, '$options', {
      enumerable: false,
      configurable: true,
      get: function get() {
        return config;
      }
    });
    (0, _mixin.mixinComputed)(this, config.computed);
    (0, _initWatch.default)(this, config.watch);

    if (typeof config.created === 'function') {
      config.created.call(this);
    }
  }
  /**
   * Register an SFC plugin
   */


  _createClass(SFC, [{
    key: "render",

    /**
     * Need override
     */
    value: function render() {
      return null;
    }
    /**
     * Need override
     */

  }, {
    key: "forceUpdate",
    value: function forceUpdate() {}
  }], [{
    key: "use",
    value: function use(Plugin, options) {
      if (Plugin == null) {
        throw new TypeError('Plugin should not be undefined or null');
      }

      if (installedPlugins.has(Plugin)) {
        if (process.env.NODE_ENV !== 'production') console.error("SFC: Plugin ".concat(Plugin.name, " can not use more than once."));
        return;
      }

      Plugin.install(SFC, options);
      installedPlugins.add(Plugin);
    }
  }]);

  return SFC;
}();

exports.default = SFC;