"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isObject = isObject;
exports.isPlainObject = isPlainObject;
exports.isNative = isNative;
exports.noop = noop;
exports.parsePath = parsePath;
exports.kebabCase = kebabCase;
exports.warn = runtimeWarn;
Object.defineProperty(exports, "uppercamelcase", {
  enumerable: true,
  get: function get() {
    return _uppercamelcase.default;
  }
});
Object.defineProperty(exports, "camelcase", {
  enumerable: true,
  get: function get() {
    return _camelcase.default;
  }
});
Object.defineProperty(exports, "isWeb", {
  enumerable: true,
  get: function get() {
    return _universalEnv.isWeb;
  }
});
Object.defineProperty(exports, "isNode", {
  enumerable: true,
  get: function get() {
    return _universalEnv.isNode;
  }
});
Object.defineProperty(exports, "isWeex", {
  enumerable: true,
  get: function get() {
    return _universalEnv.isWeex;
  }
});
Object.defineProperty(exports, "isReactNative", {
  enumerable: true,
  get: function get() {
    return _universalEnv.isReactNative;
  }
});

var _uppercamelcase = _interopRequireDefault(require("uppercamelcase"));

var _camelcase = _interopRequireDefault(require("camelcase"));

var _universalEnv = require("universal-env");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

// including any obj
function isObject(obj) {
  return obj !== null && _typeof(obj) === 'object';
}

function isPlainObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
}

function isNative(Ctor) {
  return typeof Ctor === 'function' && /native code/.test(Ctor.toString());
}

function noop() {}
/**
 * Parse simple path.
 */


var bailRE = /[^\w.$]/;

function parsePath(path) {
  if (bailRE.test(path)) {
    return;
  }

  var segments = path.split('.');
  return function (obj) {
    for (var i = 0; i < segments.length; i++) {
      if (!obj) {
        return;
      }

      obj = obj[segments[i]];
    }

    return obj;
  };
}

function kebabCase(string) {
  var kebab = '';

  for (var i = 0, l = string.length; i < l; i++) {
    if (/[a-z]/.test(string[i])) {
      kebab += string[i];
    } else if (/[A-Z]/.test(string[i])) {
      kebab += '-' + string[i].toLowerCase();
    } else if (string[i] === '-') {
      kebab += '-';
    }
  }

  if (kebab[0] === '-') {
    return kebab.slice(1);
  } else {
    return kebab;
  }
}

function runtimeWarn() {
  var _console$warn;

  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  (_console$warn = console.warn).call.apply(_console$warn, [console, '[SFC WARN]'].concat(args));
}